
;*** SC2 Picture Viewer v.0.9 for MSX

;*** To assembLe it go to http://clrhome.org/asm/

#define	LF	0ah
#define	CR	0dh
#define	BDOS	00005h
#define	CALSLT	0001Ch
#define	FCB	0005ch
#define	MNROM	0FCC1h
#define	BUFTOP	08000h
#define	progStart	$100
.org	progStart

	jp	MAIN

MesVer:
.db	CR,LF,"SC2 Picture Viewer",CR,LF
.db	" v.0.9 by GDX",CR,LF,CR,LF,24h
ErrMes:
.db	"File reading error !",CR,LF,CR,LF
.db	"Usage: SC2VIEW filename.ext",CR,LF,24h
Completed:
.db	"Completed.",CR,LF,24h



MAIN:
	ld	de,MesVer
	ld	c,9
	call	BDOS			; Print MesVer message

PreFCB:
	ld	bc,24			; Prepare the FCB
	ld	de,FCB+13
	ld	hl,FCB+12
	ld	(hl),b
	ldir				; Initialize the second half with zero

	ld	c,0fh
	ld	de,FCB
	call	BDOS			; Open file
	ld	hl,1
	ld	(FCB+14),hl		; Record size = 1 byte
	or	a
	ld	de,ErrMes		; DE = Error message address
	jp	nz,Done

	ld	c,1ah
	ld	de,BUFTOP
	call	BDOS			; Set disk transfer address (buffer start)

	ld	c,27h
	ld	de,FCB
	ld	hl,03807H		; Number of records to read
	call	BDOS			; Read picture file

	ld	a,(0F3E9h)	; Text color
	ld	(TextColor),a
	ld	a,(0F3EAh)	; Back color
	ld	(BackColor),a
	ld	a,(0F3EBh)	; Border color
	ld	(BorderColor),a

	xor	a
	ld	(0F3E9h),a	; Hide cursor
	ld	(0F3EAh),a	; Back color = 0
	ld	(0F3EBh),a	; Border color = 0
	ld	a,2
	ld	(0FCAFH),a
	ld	iy,(MNROM-1)
	ld	ix,005Fh
	call	CALSLT		; SCREEN 2 mode

	ld	hl,BUFTOP+7
	ld	de,0
	ld	bc,03800h
	ld	iy,(MNROM-1)
	ld	ix,005Ch
	call	CALSLT		; Transfert Ram to Vram

WaitSpaceKey:
	ld	iy,(MNROM-1)
	ld	ix,00D8h
	call	CALSLT		; Test space key
	or	a
	jr	z,WaitSpaceKey
WaitNotSpaceKey:
	ld	iy,(MNROM-1)
	ld	ix,00D8h
	call	CALSLT		; Test space key
	or	a
	jr	nz,WaitNotSpaceKey

	ld	hl,(0F3F8h)
	ld	(0F3FAh),hl	; Kill keyboard buffer
	ld	(hl),0

	ld	a,(TextColor)
	ld	(0F3E9h),a	; Restore text color
	ld	a,(BackColor)
	ld	(0F3EAh),a	; Restore back color
	ld	a,(BorderColor)
	ld	(0F3EBh),a	; Restore border color

	ld	iy,(MNROM-1)
	ld	ix,006Ch
	call	CALSLT		; back to text mode
	
	ld	de,Completed
Done:
	ld	c,9
	call	BDOS			; Print back message
	
	rst	0		; back to MSX-DOS
TextColor:
.db	0
BackColor:
.db	0
BorderColor:
.db	0
